{$F+}
Unit ExecVars;
{Contains the global variables required by the simple array based Turbo
Pascal executive. This is a unit which may be separately compiled.
As procedural types are used, the compilation must force far calls, hence
the $F+ compiler directive at the head of the unit}

Interface

Const MaxEnt = 30;                         {Don't try more than 30 entities}
      MaxC = 10;                           {Max No of C Activities}

Type BAct = Procedure;
     CAct = Procedure;
     Observations = Array[1..100] of Integer;
     EntDetails = Record                   {Holds entity information}
                  Name : String;           {Entity name for listings}
                  Avail : Boolean;         {Indicates whether occupied}
                  TimeCell : Integer;      {TimeCell}
                  NextAct : BAct;          {Next B activity, if one due}
                  Util : Integer;          {Utilisation time}
                  End;

Var Details : Array[1..MaxEnt] of EntDetails;
    CArray : Array[1..MaxC] of Procedure;
    NumCurrEnts : Integer;                     {Used in APhase & BPhase}
    Clock, PrevClock : Integer;                {Current simulation time}
    RunDuration : Integer;                 {Length of run}
    NumEnts : Integer;                     {Number of entities}
    NumCs : Integer;                       {Number of C Activities}
    CurrEntArray : Array[1..MaxEnt] of Integer; {Entities due now}
    CurrEnt : Integer;                     {Entity involved in current B}
    CStarted : Boolean;                    {Used in CPhase for repeat scans}

Implementation                             {Empty, unit only declarations}

End.  {Of the ExecVars unit}