Program PasExec;

{Contains APhase, BPhase & CPhase as used in the main program for the
simple array based Turbo Pascal Executive. This program uses the other
units to produce an executable simulation}

Uses ExecVars, GenLib, ExecUtil, Model, Crt;

Procedure Aphase;
{Time scan by examining the Details array of records. Checks all entities
for which Avail is false. For these, finds those with the smallest timecells
and puts the number of the entity into the CurrEntArray}
Var Entity, Minm : Integer;
Begin
NumCurrEnts := 0;
Minm := MaxInt;
For Entity := 1 to NumEnts do
    With Details[Entity] do
         If Not Avail then
            Begin
            If Timecell <= Minm then
               Begin
               If TimeCell < Minm then NumCurrEnts := 1
                 Else NumCurrEnts := NumCurrEnts + 1;
               Minm := TimeCell;
               CurrEntArray[NumCurrEnts] := Entity;
               End;
            End;
If Minm = MaxInt then Error('Error in A phase, Minm still = MaxInt');
If Minm < 0 then Error('Seems to be a mistake in A phase, Minm -ve');
PrevClock := Clock;
Clock := Minm;
End;

Procedure Bphase;
{Works through the CurrEntArray. For each entity number stored in CurrEntArray,
executes the B activity indicated for that entity. Executed after A phase
and before C phase}
Var Loop : Integer;
Begin
If TraceOn then
   Begin
   Writeln(TraceFile);
   Writeln(TraceFile, 'Time now .. ', Clock:5);
   End;
ShowEntDetails;
For Loop := 1 to NumCurrEnts do
    Begin
    CurrEnt := CurrEntArray[Loop];
    With Details[CurrEnt] do
         Begin
         Avail := True;             {Release CurrEnt}
         NextAct;                   {Do this B Activity}
         End;
    End;
End;


Procedure Cphase;
{Try each C activity in turn}
Var Loop : Integer;
Begin
Repeat
      CStarted := False;
      For Loop := 1 to NumCs do CArray[Loop];
Until Not CStarted;
End;

Procedure CheckInterrupt;
{Checks whether user has hit the keyboard. If so, pauses, then asks for
continuation or termination}
Var Key : Char;
Begin
If KeyPressed then
   Begin
   Key := ReadKey;              {Empty keyboard buffer}
   BeepClear(1, 22);
   Gotoxy(22, 20);Write('Press <ESC> to halt, any other key to continue');
   If (Ord(ReadKey) = 27) then
      Begin
      Finalisation;
      Halt(99);
      End
   Else
       InterruptMessage;
   End;
End;

Procedure ScreenDelay;
{Delays screen as specified in initialisation}
Begin
If (DisplayDelay > 0) then
   Delay(DisplayDelay);
End;

{***************************************************************************
**********************   Main Program  *************************************
***************************************************************************}
Begin       {Main program}
Initialisation;
While Clock <= RunDuration do
      Begin
      Aphase;
      Bphase;
      Cphase;
      UpDateScreen;
      ScreenDelay;
      CheckInterrupt;
      End;
Finalisation;
End.
